> The project has been tested on Ubuntu 14.04.5 with ROS Indigo  

# Directory description  
1. /data : record data including pointcloud and image
2. /ros_pkg: this project which runs as a ros node  
3. /vrep: vrep scene file
4. README.md: this file

# Project dependencies  
1. Eigen 3
2. PCL 1.7.2
3. Opencv
4. Boost  
5. g2o (https://github.com/RainerKuemmerle/g2o)  
6. libpointmatcher(https://github.com/ethz-asl/libpointmatcher)  
7. EDline(/ros_pkg/thirdparty)
8. json (/ros_pkg/thirdparty OR https://github.com/nlohmann/json)  
9. Vrep for simulation(not for project compiling)

# How to Start
1. re-compile `libv_repExtRosInterface.so` for vrep since we use the vrep ros interface and our own service massage. Note: compile it with the service in /ros_pkg/srv/ExCalibration.srv   
2. run `roscore` OR use our launch file 
3. run vrep -> load the `/vrep/sim.ttt` scene -> start the simulation  
4. launch the ros node with config file path as parameters:  
```shell
./demo ../config/config.json ../../data/0301/
# ../config/congig.json is the config file path  
# ../../data/0301/ is the saving data directory
```

# Config file
`/config/config.json` is the project config file which should be re-editted according to your configuration.   
1. `is_simulate`: `true` use the vrep simulation and `false` will load data from disk  
2. `record_num`: the record number when `is_simulate` is `true`  
3. `intrinsic_fx_fy_s_u_v`: the camera intrinsic parameter  
